summaryrefslogtreecommitdiff
path: root/debian/initramfs
diff options
context:
space:
mode:
authorDimitri John Ledkov <xnox@ubuntu.com>2016-07-02 19:16:01 +0100
committerDimitri John Ledkov <xnox@ubuntu.com>2016-07-02 19:16:01 +0100
commitb83f8fcaffa542498c5698a3a161b9967ac1d3d6 (patch)
tree3cb83259723d112fd7b08b5bd299df2f5ee94009 /debian/initramfs
mdadm (3.4-2) unstable; urgency=low
* Reneable incremental assembly * Rely on udev to assemble incremental arrays * In environments with systemd rely on mdadm-last-resort@.timer|.service units to activate degrated raids * In environments initramfs-tools initrd (no systemd) add local-block script to do the same after 2/3rds of root delay iteration * Drop local-top initramfs script * Drop dependency on initscripts package * Drop INITRDSTART support * Drop mdadm-raid init script * Drop ancient preinst * In mdadm.init remove dependency on mdadm-raid * In mdadm.init check, and bail out running in a container * In mdadm.config drop mdadm/autostart logic * Drop CREATE stanzas from mkconf and don't include them in the initramfs. The generated defaults, are the compiled-in defaults. And the current one generates warnings when running mdadm in the initramfs, as there is no passwd|group files to resolve root/disk uid/gid. Closes: 717609 * Adapt changes and formatting of initramfs hook from Ubuntu * Bump standards version to 3.9.7, no changes required * Fix copyright-refers-to-symlink-license * Closes: #781172, #796624, #769201, #813335, #632401, #804973, #714155, #770002, #737132, #675452, #726390, #813637, #814036. # imported from the archive
Diffstat (limited to 'debian/initramfs')
-rw-r--r--debian/initramfs/hook110
-rw-r--r--debian/initramfs/script.local-block44
-rw-r--r--debian/initramfs/script.local-bottom3
3 files changed, 157 insertions, 0 deletions
diff --git a/debian/initramfs/hook b/debian/initramfs/hook
new file mode 100644
index 00000000..ae7d4d18
--- /dev/null
+++ b/debian/initramfs/hook
@@ -0,0 +1,110 @@
+#!/bin/sh
+#
+# Copyright © 2006-2008 Martin F. Krafft <madduck@debian.org>,
+# 2012 Michael Tokarev <mjt@tls.msk.ru>
+# based on the scripts in the initramfs-tools package.
+# released under the terms of the Artistic Licence.
+#
+set -eu
+
+PREREQ="udev"
+prereqs()
+{
+ echo "$PREREQ"
+}
+
+case "${1:-}" in
+ prereqs)
+ prereqs
+ exit 0
+ ;;
+esac
+
+is_true()
+{
+ case "${1:-}" in
+ [Yy]es|[Yy]|1|[Tt]rue|[Tt]) return 0;;
+ *) return 1;;
+ esac
+}
+
+write()
+{
+ local PREFIX; PREFIX=$1; shift
+ echo "${PREFIX}: mdadm: $@" >&2
+}
+
+info()
+{
+ is_true ${VERBOSE:-false} && write I "$@" || :
+}
+
+warn()
+{
+ write W "$@"
+}
+
+. /usr/share/initramfs-tools/hook-functions
+
+# copy the binary as early as possible
+copy_exec /sbin/mdadm /sbin
+copy_exec /sbin/mdmon /sbin
+
+# Copy udev rules, which udev no longer does
+for UDEV_RULE in 63-md-raid-arrays.rules 64-md-raid-assembly.rules; do
+for rules_folder in /lib/udev/rules.d /etc/udev/rules.d; do
+ if [ -f $rules_folder/$UDEV_RULE ]; then
+ mkdir -p $DESTDIR$rules_folder
+ cp $rules_folder/$UDEV_RULE $DESTDIR$rules_folder/$UDEV_RULE
+ fi
+done
+done
+
+# load raid modules in the initramfs
+for module in linear multipath raid0 raid1 raid456 raid5 raid6 raid10; do
+ force_load $module
+done
+
+# copy the mdadm configuration
+CONFIG=/etc/mdadm/mdadm.conf
+ALTCONFIG=/etc/mdadm.conf
+DESTMDADMCONF=$DESTDIR/etc/mdadm/mdadm.conf
+[ ! -f $CONFIG ] && [ -f $ALTCONFIG ] && CONFIG=$ALTCONFIG || :
+mkdir -p ${DESTDIR}/etc/mdadm
+
+if [ ! -f $CONFIG ]; then
+ # there is no configuration file, so let's create one
+ if /usr/share/mdadm/mkconf generate $CONFIG; then
+ # all is well
+ cp -p $CONFIG $DESTMDADMCONF
+ info "auto-generated the mdadm.conf configuration file."
+ else
+ # we failed to auto-generate, so let the emergency procedure take over
+ warn "failed to auto-generate the mdadm.conf file."
+ warn "please read /usr/share/doc/mdadm/README.upgrading-2.5.3.gz ."
+ fi
+else
+ cp -p $CONFIG ${DESTDIR}/etc/mdadm
+ sed -i '/^CREATE/s/^/#/' $DESTMDADMCONF
+ if ! grep -q '^ARRAY' $CONFIG; then
+ tmpfile="${DESTMDADMCONF}.tmp"
+ warn "$CONFIG defines no arrays."
+ if /usr/share/mdadm/mkconf > $tmpfile; then
+ cp -p $tmpfile $DESTMDADMCONF
+ else
+ warn "failed to auto-generate temporary mdadm.conf file."
+ fi
+ else
+ # make sure the configuration file knows about all running devices
+ /sbin/mdadm --detail --scan | while read array device params; do
+ uuid=${params#*UUID=}; uuid=${uuid%% *}
+ if ! grep -q "UUID=$uuid" $DESTMDADMCONF; then
+ warn "the array $device with UUID $uuid"
+ warn "is currently active, but it is not listed in mdadm.conf. if"
+ warn "it is needed for boot, then YOUR SYSTEM IS NOW UNBOOTABLE!"
+ warn "please inspect the output of /usr/share/mdadm/mkconf, compare"
+ warn "it to $CONFIG, and make the necessary changes."
+ fi
+ done
+ fi
+fi
diff --git a/debian/initramfs/script.local-block b/debian/initramfs/script.local-block
new file mode 100644
index 00000000..e9b47c3d
--- /dev/null
+++ b/debian/initramfs/script.local-block
@@ -0,0 +1,44 @@
+#!/bin/sh
+
+PREREQ="multipath"
+
+prereqs()
+{
+ echo "$PREREQ"
+}
+
+case $1 in
+# get pre-requisites
+prereqs)
+ prereqs
+ exit 0
+ ;;
+esac
+
+# Poor man's mdadm-last-resort@.timer
+# That kicks in 2/3rds into the ROOTDELAY
+
+if [ ! -f /run/count.mdadm.initrd ]
+then
+ COUNT=0
+else
+ COUNT=$(cat /run/count.mdadm.initrd)
+fi
+COUNT=$((COUNT + 1))
+
+echo $COUNT > /run/count.mdadm.initrd
+
+MAX=30
+if [ ${ROOTDELAY:-0} -gt $MAX ]; then
+ MAX=$ROOTDELAY
+fi
+MAX=$((MAX*2/3))
+
+if [ "$COUNT" = "$MAX" ]
+then
+ # Poor man's mdadm-last-resort@.service
+ mdadm -q --run /dev/md?*
+ rm -f /run/count.mdadm.initrd
+fi
+
+exit 0
diff --git a/debian/initramfs/script.local-bottom b/debian/initramfs/script.local-bottom
new file mode 100644
index 00000000..eda3b179
--- /dev/null
+++ b/debian/initramfs/script.local-bottom
@@ -0,0 +1,3 @@
+#!/bin/sh
+rm -f /run/count.mdadm.initrd
+exit 0 \ No newline at end of file